unit chatlane;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,  Controls, Forms,
  Dialogs, StdCtrls, ScktComp, Buttons, ExtCtrls,Graphics;

type
  TChatlaninForm = class(TForm)
    ConnectButton: TButton;
    DisconnectButton: TButton;
    HostEdit: TEdit;
    PortEdit: TEdit;
    NickEdit: TEdit;
    UsersListBox: TListBox;
    MessEdit: TEdit;
    ClientSocket1: TClientSocket;
    DialogMemo: TMemo;
    SendButton: TButton;
    PortLabel: TLabel;
    NickLabel: TLabel;
    HostLabel: TLabel;
    UsersLabel: TLabel;
    PrivateCheckBox: TCheckBox;
    PrivatLabel: TLabel;
    procedure ConnectButtonClick(Sender: TObject);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocket1Lookup(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure DisconnectButtonClick(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure SendButtonClick(Sender: TObject);
    procedure MessEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
 private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ChatlaninForm: TChatlaninForm;
  Nick: string;
  Bmp: TBitMap;

implementation

{$R *.dfm}

procedure TChatlaninForm.ConnectButtonClick(Sender: TObject);
var Host,Port: string;
  begin
    {   }
    Host := HostEdit.Text;
    Port := PortEdit.Text;
    Nick := NickEdit.Text;
    Caption:='ChatLANin';
    Caption:=Caption+' - '+Nick;
    {   ,   }
    if ClientSocket1.Active then
     ClientSocket1.Close;
    { Host  Port}
    ClientSocket1.Host := Host;
    ClientSocket1.Port := StrToInt(Port);
    {}
    ClientSocket1.Open;
    ActiveControl := MessEdit;
  end;

procedure TChatlaninForm.ClientSocket1Error(Sender: TObject;
    Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
    var ErrorCode: Integer);
  begin
    {  }
//    DialogMemo.Lines.Add('    ('+IntToStr(ErrorCode)+')');
    DialogMemo.Lines.Add('    ('+IntToStr(ErrorCode)+')');
  end;
  
procedure TChatlaninForm.ClientSocket1Lookup(Sender: TObject;
    Socket: TCustomWinSocket);
  begin
    { }
    DialogMemo.Lines.Add(': '+ Nick);
//    DialogMemo.Lines.Add(': '+ ClientSocket1.Socket.LocalHost);
//    DialogMemo.Lines.Add('  '+ HostEdit.Text);
    DialogMemo.Lines.Add(': '+ ClientSocket1.Socket.LocalHost);
    DialogMemo.Lines.Add(' '+ HostEdit.Text);

  end;

procedure TChatlaninForm.ClientSocket1Connecting(Sender: TObject;
  Socket: TCustomWinSocket);
  begin
    {}
//    DialogMemo.Lines.Add(', ...');
    DialogMemo.Lines.Add(' IP ...');
  end;

procedure TChatlaninForm.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
  begin
    {}
//    DialogMemo.Lines.Add (' ,  :)');
   DialogMemo.Lines.Add (' ');
  end;

procedure TChatlaninForm.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
  begin
    { }
//    DialogMemo.Lines.Add(' ,  !');
    DialogMemo.Lines.Add(' ');
  end;

procedure TChatlaninForm.DisconnectButtonClick(Sender: TObject);
  begin
   { }
   if ClientSocket1.Active then
    ClientSocket1.Close;
  end;

procedure TChatlaninForm.ClientSocket1Read(Sender: TObject;
    Socket: TCustomWinSocket);
    var s, FromNick, ToNick, PrivateTime: string;
    var k:integer;
  begin
    {  s    }
    s := Socket.ReceiveText;
    {   }
    if Copy(s,1,2) = '^U' then begin
     Delete(s,1,2);
     UsersListBox.Items.Clear;
     {   .   ";"}
     while Pos(';',s) > 0 do begin
      if (Copy(s,1,2) = '^U') then Break;
      UsersListBox.Items.Add(Copy(s,1,Pos(';',s)-1));
      Delete(s,1,Pos(';',s));
     end;
     Exit;
    end;
    {  }
    if Copy(s,1,2) = '^M' then begin
     Delete(s,1,2);
     { }
     DialogMemo.Lines.Add(s);
     //Copy(s,1,Pos(';',s)-1)+
     //     Copy(s,Pos(';',s)+1,Length(s)-Pos(';',s)));
     Exit;
    end;
    {     }
    if Copy(s,1,2) = '^N' then begin
     {   }
     Socket.SendText('^N'+Nick);
     Exit;
    end;
    {  }
    if Copy(s,1,2) = '^P' then begin
      Delete(s,1,2);
     {   }
      ToNick := Copy(s,1,Pos(';',s)-1);
      Delete(s,1,Pos(';',s));
     {  }
      PrivateTime := Copy(s,1,Pos(' ',s)-1);
      Delete(s,1,Pos(' ',s));
     {   }
      FromNick := Copy(s,1,Pos('-',s)-2);
      Delete(s,1,Pos('-',s)+1);
     {       -   DialogMemo}
     if (ToNick = Nick)or(FromNick = Nick) then
 DialogMemo.Lines.Add(PrivateTime+' '+FromNick+' -- c '+ToNick+' - '+s);
     Exit;
    end;
  end;

procedure TChatlaninForm.SendButtonClick(Sender: TObject);
var s: string;
  begin
  {   ,    }
  if (PrivateCheckBox.Checked)and(UsersListBox.ItemIndex < 0) then
    begin
     ShowMessage('    ???');
     Exit;
    end;
  {   }
  if PrivateCheckBox.Checked then
   s := '^P'+UsersListBox.Items[UsersListBox.ItemIndex]+';'
    else {  }
   s := '^M';

   {, , }
   s := s+'['+TimeToStr(Time)+']'+ ' '+Nick+' - '+MessEdit.Text;
   {}
   ClientSocket1.Socket.SendText(s);
   {   }
   MessEdit.Text := '';
   ActiveControl := MessEdit;
  end;

procedure TChatlaninForm.MessEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  begin
   {    Enter}
   if Key = VK_RETURN then
    SendButton.Click;
  end;

procedure TChatlaninForm.FormCreate(Sender: TObject);
var TxtColor, LabelColor, LabelFontColor:integer;
  begin
// ChatlaninForm.Brush.Bitmap := TBitMap.Create;
//  ChatlaninForm.Brush.Bitmap.LoadFromFile('4.bmp');
//  PrivateCheckBox.Brush.Bitmap := TBitMap.Create;
//  PrivateCheckBox.Brush.Bitmap.LoadFromFile('4.bmp');

   TxtColor:=clWindow;
   LabelColor:=16104653;
   LabelFontColor:=clWindow;

   HostEdit.Color:=TxtColor;
   PortEdit.Color:=TxtColor;
   NickEdit.Color:=TxtColor;
   DialogMemo.Color:=TxtColor;
   UsersListBox.Color:=TxtColor;
   MessEdit.Color:=TxtColor;
   UsersListBox.Color:=TxtColor;

   HostLabel.Font.Color:=LabelFontColor;
   PortLabel.Font.Color:=LabelFontColor;
   NickLabel.Font.Color:=LabelFontColor;
   UsersLabel.Font.Color:=LabelFontColor;
  end;

procedure TChatlaninForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i: 0..255;
 begin
  for i := 255 downto 0 do
   begin
     AlphaBlendValue := i;
     Application.ProcessMessages;
   end;
 end;

procedure TChatlaninForm.FormActivate(Sender: TObject);
var
  i, j: 0..255;
 begin
  AlphaBlendValue:=0;
  for i := 0 to 255 do
   begin
     AlphaBlendValue := i;
     Application.ProcessMessages;
   end;
end;

procedure TChatlaninForm.FormDestroy(Sender: TObject);
 begin
   ChatlaninForm.Brush.Bitmap.Free;
 end;

end.
